extends CharacterBody2D

const MOVE_SPEED = 50
const DECAY_MOVE_SPEED = 0.9 
const GRAVITY = 50
const JUMP_POWER = 1000

@onready var _spr = $Player

var _is_jumping = false # ジャンプ中かどうか
var _is_directon_left = false # 左向きかどうか.
var _tAnim:float = 0 # アニメーションタイマー.

func _physics_process(delta: float) -> void:
	# 重力を加算
	velocity.y += GRAVITY
	
	# 移動量を減衰.
	velocity.x *= DECAY_MOVE_SPEED
	
	# 左右移動.
	if Input.is_action_pressed("ui_left"):
		velocity.x -= MOVE_SPEED # 左方向に移動
	elif Input.is_action_pressed("ui_right"):
		velocity.x += MOVE_SPEED # 右方向に移動.
	
	# ジャンプ.
	if _is_jumping == false:
		# ジャンプ中でなければジャンプできる.
		if Input.is_action_just_pressed("ui_accept"):
			# SPACEキーでジャンプする.
			velocity.y = -JUMP_POWER
	
	# 移動処理.
	move_and_slide()
	
	if is_on_floor():
		_is_jumping = false # 床に着地している
	else:
		_is_jumping = true # ジャンプ中.

func _process(delta: float) -> void:
	_tAnim += delta
	
	# アニメーションの切り替え.
	if velocity.x < 0:
		_is_directon_left = true # 左向き
	elif velocity.x > 0:
		_is_directon_left = false # 右向き

	_spr.flip_h = _is_directon_left
	
	var tbl = [0, 1];
	var t = _tAnim
	if abs(velocity.x) > 50:
		# 速度が50以上なら走り中.
		tbl = [2, 3]
		t *= 8 # アニメーション速度を上げる

	t = int(t) % 2
	_spr.frame = tbl[t]
	
	if _is_jumping:
		# ジャンプ中は2番目固定.
		_spr.frame = 2
